/* 
   SquidTL - Time Limit for Squid proxy
   Copyright (C) 2009-2010, Michele Pinassi <o-zone@zerozone.it>.
   
   http://www.zerozone.it/Software/Linux/SquidTL
                                                                     
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "config.h"

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <stdarg.h>
#include <signal.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <assert.h>
#include <mysql.h>
#include <time.h>
#include <sys/vfs.h>
       
#ifdef PCRE
#include <pcre.h> /* Perl Regular Expression */
#else
#include <regex.h> /* Provides regular expression matching */
#endif

#include <strings.h> /* String utillity functions */
#include <errno.h> /* Handle errors */


#ifdef XMLRPC
#include <xmlrpc-c/base.h>
#include <xmlrpc-c/client.h>
#endif

#include <libxml/parser.h>
#include <libxml/tree.h>

#define NAME "SquidTL"

/* Definitions for log */
#define DEBUG 1
#define NOTICE 2
#define WARNING 3
#define ERROR 4
#define FATAL 5

/* Configuration struct for SquidTL */
struct _Config {
    char defaultMode[32];
    char defaultAction[32];
    char defaultRedirectURL[255];
    char defaultUserAction[32];
    char URLListPath[255];
    unsigned int defaultUserLevel;
    unsigned int defaultUserGroup;
    unsigned int purgeTimeout;
    char xmlrpcServer[255];
    char mysqlHost[32];
    char mysqlPort[16];
    char mysqlDb[32];
    char mysqlUser[32];
    char mysqlPassword[32];
};
