<?php

include_once('config.inc.php');

# Do not touch this !
$myVersion = "0.1.1";

$echoMessage = '';

include('IXR_Library.inc.php');

# SESSION INIT
session_start();

# SUPPORTO MULTILINGUE
include "lang/en.inc.php";

if(file_exists("lang/".substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2).".inc.php")) {
    include "lang/".substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2).".inc.php";
}

function isSelected($value,$match) {
    if($value == $match) return "selected";
}

function isChecked($value) {
    if($value) return "checked";
}

function getString($idx) {
    global $TLANG;
    if(strlen($TLANG[$idx]) > 0) {
	return $TLANG[$idx];
    } else {
	return "[$idx]";
    }
}

function OpenDB()
{
    global $CFG;
    $db = mysql_connect($CFG["dbHost"],$CFG["dbUser"],$CFG["dbPwd"]);
    if($db == false) {
	echo getString("mysql-connection-failed").": ".mysql_error();
	return false;
    }
    if(mysql_select_db($CFG["dbName"],$db) == false) {
	return false;
    }
    return $db;
}

function CleanInput($u_Input) {
    $banlist = array (
	" insert ", " select ", " update ", " delete ", " distinct ", " having ", " truncate ", " replace ",
	" handler ", " like ", " as ", " or ", " procedure ", " limit ", " order by ", " group by ", " asc ", " desc "
    );
    $replacelist = array (
	" ins3rt ", " s3lect ", " upd4te ", " d3lete ", " d1stinct ", " h4ving ", " trunc4te ", " r3place ",
	" h4ndler ", " l1ke ", " 4s ", " 0r ", " procedur3 ", " l1mit ", " 0rder by ", " gr0up by ", " 4sc ", " d3sc "
    );
    if(eregi( "[a-zA-Z0-9]+", $u_Input )) {
	$u_Input = trim(str_replace($banlist, $replacelist, $u_Input));
    } else {
	$u_Input = NULL;
    }
    return $u_Input;
}

function GetClientIP() {
    if(getenv('HTTP_X_FORWARDED_FOR')) {
	return getenv('REMOTE_ADDR')." (".getenv('HTTP_X_FORWARDED_FOR').")";
    } else {
	return getenv('REMOTE_ADDR');
    }
}

function PrintDateTime($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode("-",$date_str);
    list($hour,$min,$secs) = explode(":",$time_str);
    if($year == "0000") return "NEVER";
    $date_str = $day."/".$month."/".$year." ".$hour.":".$min.":".$secs;
    return $date_str;
}

function PrintTimestamp($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode("-",$date_str);
    list($hour,$min,$secs) = explode(":",$time_str);
    $date_str = $hour.":".$min.":".$secs;
    return $date_str;
}

function PrintExifDateTime($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode(":",$date_str);
    list($hour,$min,$secs) = explode(":",$time_str);
    $date_str = $day."/".$month."/".$year." ".$hour.":".$min.":".$secs;
    return $date_str;
}
 
function RFC822DateTime($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode("-",$date_str);
    list($hour,$min,$secs) = explode(":",$time_str);
    $timestamp = mktime($hour,$min,$secs,$month,$day,$year);
    return date("r",$timestamp);
}

function DateTimeDiff($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode("-",$date_str);
    list($hour,$min,$secs) = explode(":",$time_str);
    return time() - mktime($hour,$min,$secs,$month,$day,$year);
}

function DateDiff($u_DateTime) {
    list($date_str,$time_str) = explode(" ",$u_DateTime);
    list($year,$month,$day) = explode("-",$date_str);
    $today = getdate(); 
    return mktime(0,0,0,$today['mon'],$today['$mday'],$today['year']) - mktime(0,0,0,$month,$day,$year);
}

function PrintApproxDateTime($u_DateTime) {
    $diff = DateTimeDiff($u_DateTime);
    if($diff < 60) {
	return $diff."s";
    } else {
	$secs = $diff % 60;
	$mins = ($diff-$secs) / 60;
	if($mins > 60) {
	    $mint = $mins % 60;
	    $hours = ($mins - $mint) / 60;
	    if($hours > 24) {
		$hourt = $hours % 24;
		$days = ($hours-$hourt) / 24;
		return $days."d ".$hourt."h ".$mint."m ".$secs."s";  
	    } else {
		return $hours."h ".$mint."m ".$secs."s"; 
	    }
	} else {
	    return $mins."m ".$secs."s"; 
	}
    } 
}

function PrintDate($u_Date) {
    list($date_str,$time_str) = explode(" ",$u_Date);
    list($year,$month,$day) = explode("-",$date_str);
    if(($day > 0)&($month > 0)&($year > 0)) {
	$date_str = $day."/".$month."/".$year;
    } elseif (($month > 0)&($year > 0)) {
	$date_str = $month."/".$year;
    } elseif (($month > 0)&($year > 0)) {
	$date_str = $year;
    } else {
	$date_str = "";
    }    
    return $date_str;
}

function PrintTime($u_Date) {
    list($date_str,$time_str) = explode(" ",$u_Date);
    list($hour,$min,$secs) = explode(":",$time_str);
    $time_str = "$hour:$min:$secs";
    return $time_str;
}

function PrintExpTime($u_Time) {
    list($hour,$min,$secs) = explode(":",$u_Time);
    if(($min > 0)&($secs > 0)) {
	if($hour > 0) {
	    $time_str = $hour."h ".$min."m ".$secs."s";
	} else {
	    $time_str = $min."m ".$secs."s";
	}
    } else {
	$time_str = "";
    }
    return $time_str;
}

function isLogged($sid) {
    /* Make sure the connection is still alive, if not, try to reconnect */
    if(!mysql_ping()) {
	return;
    }
    $result = mysql_query("SELECT Username FROM DB_Sessions WHERE ID='$sid' AND TIMESTAMPDIFF(MINUTE,LastUpdate,NOW()) < 60;");
    if($result === false) {
        printf("[isLogged] %s\n",mysql_error());
        exit();
    }
    if(mysql_num_rows($result) > 0) {
        $row = mysql_fetch_array($result,MYSQL_ASSOC);
	/* Rinnova la sessione */    
    	mysql_query("UPDATE DB_Sessions SET LastUpdate=NOW() WHERE ID='$sid';");
	return stripslashes($row["Username"]);
    } else {
	return false;
    }
}

function getContext($userName) {
    $result = mysql_query("SELECT Type,Context FROM DB_Users WHERE Username='$userName';");
    if($result === false) {
        printf("[getContext] %s\n",mysql_error());
        exit();
    }
    if(mysql_num_rows($result) > 0) {
        $row = mysql_fetch_array($result,MYSQL_ASSOC);
        if($row["Type"] == 5) return '%'; /* Administrators can controll all context ! */
	return $row["Context"];
    } else {
	return false;
    }
}

function LOGWrite($message) {
    $IP = GetClientIP();
    $myMessage = mysql_escape_string($message);
    $result = mysql_query("INSERT INTO DB_Log (SessionID,Message,AddDate,IP) VALUES ('".session_id()."','$myMessage',NOW(),'$IP');");
    if($result === false) {
        return false;
    }
    return true;
}

function trimText($string, $word_count=100) {
   $trimmed = "";
   $string = preg_replace("#\[.*\]#","", trim($string));
   $string = preg_replace("/\040+/"," ", trim($string));
   $stringc = explode(" ",$string);
   if($word_count >= sizeof($stringc))
   {
       // nothing to do, our string is smaller than the limit.
     return $string;
   }
   elseif($word_count < sizeof($stringc))
   {
       // trim the string to the word count
        for($i=0;$i<$word_count;$i++)
        {
           $trimmed .= $stringc[$i]." ";
        }
	$continue = "<i>...</i>";
        if(substr($trimmed, strlen(trim($trimmed))-1, 1) == '.')
	    return trim($trimmed).$continue;
        else	
	     return trim($trimmed).$continue;
	}
}

function headerCheckAcl($myAcl) {
    $myUsername = isLogged(session_id());
    if($myUsername) {
	if(!getUserACL($myUsername,$myAcl)) {
    	    header('Location: /');
	}
    } else {
	/* User NOT logged in.... */
        header('Location: /');
    }	
}

function getUserACL($userName,$Type) {
    $userAcl = getUserMeta($userName,"ACL");
    if($userAcl) {
	$ACLArray = unserialize(base64_decode($userAcl));
	if(in_array($Type, $ACLArray)) {
    	    return $ACLArray[$Type];
	} 
    }
    return false;
}

function setUserACL($userName,$Type,$Value) {
    $userAcl = getUserMeta($userName,"ACL");
    if($userAcl) {
	$ACLArray = unserialize(base64_decode($userAcl));
    } else {
	$ACLArray = array();
    }
    $ACLArray[$Type] = $Value;
    $serArray = base64_encode(serialize($ACLArray));
    setUserMeta($userName,"ACL",$serArray);
}


function setUserMeta($userName,$Type,$Value) {
    $myUsername = mysql_escape_string($userName);
    $myType = mysql_escape_string($Type);
    $myValue = mysql_escape_string($Value);
    $result = mysql_query("INSERT INTO DB_UsersMeta (Username,Type,Value,AddDate) VALUES('$myUsername','$myType','$myValue',NOW()) ON DUPLICATE KEY UPDATE Value='$myValue',ChgDate=NOW();");
    if($result === false) {
        return false;
    }
    return true;
}

function getUserMeta($userName,$Type) {
    $myUsername = mysql_escape_string($userName);
    $myType = mysql_escape_string($Type);
    $result = mysql_query("SELECT Value FROM DB_UsersMeta WHERE Username='$myUsername' AND Type='$myType';");
    if($result === false) {
        printf("[getUserMeta] %s\n",mysql_error());
        exit();
    }
    if(mysql_num_rows($result) > 0) {
        $row = mysql_fetch_array($result,MYSQL_ASSOC);
	return stripslashes($row["Value"]);
    } else {
	return false;
    }
}

?>