
jQuery.fn.center = function () {
    this.css("position","absolute");
    this.css("top", ( $(window).height() - this.height() ) / 2+$(window).scrollTop() + "px");
    this.css("left", ( $(window).width() - this.width() ) / 2+$(window).scrollLeft() + "px");
    return this;
}

$(document).ready(function(){
     $("#messageBox").slideDown("slow", function() {
	setTimeout( function() { 
	    $('#messageBox').slideUp(); }, 5000
	)
    });
     $("#errorBox").slideDown("slow", function() {
	setTimeout( function() { 
	    $('#errorBox').slideUp(); }, 5000
	)
    });
});

$(function() {
	$('.date-pick').datePicker();
});
    
function clearText(obj) {
    obj.value = "";
} 

var characters='0123456789abcdefghijklmnopqrstuvwxyz';
  
var passwordlength=5;
    
function genPwd(field) {
	var password = '';
        var n = 0;
        var randomnumber = 0;
        while( n < passwordlength ) {
            n ++;
	    randomnumber = Math.floor(characters.length*Math.random());
            password += characters.substring(randomnumber,randomnumber + 1);
        }
	container = document.getElementById(field);
	container.value = password;
}
    		                
function ajaxGetAccessDetails(args,container) {
    if($(container).css('display') == "none") {
	$(container).slideDown();
	$.ajax({
	    type : 'POST',
	    url : 'ajaxCb.php',
	    data: 'action=getAccessDetails&'+args,
	    dataType: 'html',
	    beforeSend: function(XMLHttpRequest) {
		$(container).html("<img src='/img/spinner.gif'> Please wait...");
	    },
	    success: function(data) {
		$(container).html(data).fadeIn(300);
	    },
	    error: function(XMLHttpRequest, textStatus, errorThrown) {
		$(container).html('There was an error.').fadeIn(300);
	    }
	});
    } else {
	$(container).slideUp();
    }
}

function ajaxActivateRule(RuleID,isActive,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action=activateRule&ID='+RuleID+'&isActive='+isActive,
	dataType: 'html',
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}

function ajaxActivateUser(Username,isActive,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action=activateUser&ID='+Username+'&isActive='+isActive+'&Container='+container,
	dataType: 'html',
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}


function ajaxGetRulesForm(RuleID,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action=getRulesForm&ID='+RuleID,
	dataType: 'html',
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}

function ajaxAction(action,args,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action='+action+'&'+args,
	dataType: 'html',
	beforeSend: function(XMLHttpRequest) {
		$(container).html("<img src='/img/spinner.gif'> Please wait...");
	    },
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}

var axSearch=null;

function ajaxUserSearch(value,container) {
    if(value.length > 3) {
	if(axSearch) axSearch.abort()
	    axSearch = $.ajax({
	    type : 'POST',
	    url : 'ajaxCb.php',
	    data: 'action=userSearch&term='+value,
	    dataType: 'html',
	    beforeSend: function(XMLHttpRequest) {
		    $(container).html("<img src='/img/spinner.gif'> Searching...");
		},
	    success: function(data) {
		$(container).html(data).fadeIn(300);
    	    },
	    error: function(XMLHttpRequest, textStatus, errorThrown) {
		$(container).html('There was an error.').fadeIn(300);
	    }
	});
    } else {
	$(container).fadeOut(300);
    }
}

function ajaxTimeProperties(ID,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action=editTime&ID='+ID,
	dataType: 'html',
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}

function ajaxUserProperties(ID,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action=editUser&ID='+ID,
	dataType: 'html',
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}

function ajaxGroupProperties(ID,container) {
    $.ajax({
	type : 'POST',
	url : 'ajaxCb.php',
	data: 'action=editGroup&ID='+ID,
	dataType: 'html',
	success: function(data) {
	    $(container).html(data).fadeIn(300);
        },
	error: function(XMLHttpRequest, textStatus, errorThrown) {
	    $(container).html('There was an error.').fadeIn(300);
	}
    });
}
